'''
    COMPANY

    Create two classes, Company and Employee, supporting the follow operations.

        Company(name)
        
    creates a new Company object with the given str name.  
        
        Employee(name, company)

    creates a new Employee object with the given str name and associated with
    the given Company object company. Each Employee object associated with a
    given Company object is assigned a unique number 1, 2, ... when created.

        str(employee)

    returns for a given Employee object employee a string consisting of

       '<employee name>, <company name> (#<employee number>)'
    
    Input:  Multiple lines of Python code using the classes Company and Employee.
            The last line starts with '#eof' (indicating end of file).

    Output: The output generated by executing the input code.
            
    Example:

      Input:  apple = Company('Apple Computer, Inc.')
              
              steve = Employee('Steven Paul Jobs', apple)
              woz = Employee('Stephen Gary Wozniak', apple)
              
              print(steve)
              print(woz)
              
              #eof

      Output: Steven Paul Jobs, Apple Computer, Inc. (#1)
              Stephen Gary Wozniak, Apple Computer, Inc. (#2)

    Note: The below code already handles reading and executing the input.
'''


# Insert code
pass
#> solution
class Company:
    def __init__(self, name):
        self.name = name
        self.next_id = 0
    
class Employee:
    def __init__(self, name, company):
        self.name = name
        self.company = company
        company.next_id += 1
        self.id = company.next_id
    
    def __str__(self):
        return f'{self.name}, {self.company.name} (#{self.id})'
#< solution


import sys
code = ''
for line in sys.stdin:
    code += line
    if line.startswith('#eof'):
        break
#> validate last line is #eof
assert line.startswith('#eof')
#< validate
exec(code)