'''
    ALTERNATOR

    Write a generator function alternator(seq1, seq2, ..., seqn) that takes one 
    or more sequences (possibly infinite sequences) and yields their elements 
    alternately, by cycling through the sequences, and skipping over exhausted 
    sequences.
    
    E.g., 
    
        list(alternator('abc', range(1, 6), ('foo', 'bar')))

    should create the list

        ['a', 1, 'foo', 'b', 2, 'bar', 'c', 3, 4, 5]

    Input:  Multiple lines of Python code using the generator function alternator.
            The last line starts with '#eof' (indicating end of file).

    Output: The output generated by executing the input code.

    Example:

      Input:  print(list(alternator('abc', range(1, 6), ('foo', 'bar'))))
              #eof

      Output: ['a', 1, 'foo', 'b', 2, 'bar', 'c', 3, 4, 5]

    Note: The below code already handles reading and executing the input.
'''


# insert code
pass
#> solution
def alternator(*sequences):
    iterators = [iter(seq) for seq in sequences]
    while iterators:
        for seq in list(iterators):
            try:
                yield next(seq)
            except StopIteration:
                iterators.remove(seq)
#< solution


import sys
code = ''
for line in sys.stdin:
    code += line
    if line.startswith('#eof'):
        break
#> validate last line is #eof
assert line.startswith('#eof')
#< validate
exec(code)